ChkKS:
;Zakadam, e w tym miejscu procesor pracuje w trybie uytkownika (User mode).
;Kady procesor 680x0 pracuje w tym trybie, po uruchomieniu programu na Workbenchu.
;Program wywietla informacje o wersji Kickstartu, zainstalowanego w Amidze.
;Dziaa w systemie 1.2 lub nowszym i mona go uruchomi przez ikon lub z CLI.

 move.w   $F8000C,D2 ;odczyt wersji Kickstartu
 move.w   $F8000E,D3 ;odczyt rewizji Kickstartu
 moveq    #$F1,D1
 cmp.w    #$FFFF,D2
 beq.s    ChkKS1     ;Kickstart 1.x
 moveq    #$21,D1
 cmp.w    D1,D2
 beq.s    ChkKS1     ;Kickstart 1.2
 moveq    #$31,D1
 cmp.w    #$22,D2
 beq.s    ChkKS1     ;Kickstart 1.3
 moveq    #$02,D1
 cmp.w    #$24,D2
 bne.s    ChkKS0
 cmp.w    #$10,D3
 bhi.s    ChkKS1     ;Kickstart 2.0
 moveq    #$41,D1
 bra.s    ChkKS1     ;Kickstart 1.4
ChkKS0:
 cmp.w    #$25,D2
 beq.s    ChkKS1     ;Kickstart 2.0
 moveq    #$03,D1
 cmp.w    #$27,D2
 beq.s    ChkKS1     ;Kickstart 3.0
 moveq    #$13,D1
 cmp.w    #$28,D2
 beq.s    ChkKS1     ;Kickstart 3.1
 moveq    #$F3,D1    ;Kickstart 3.x
ChkKS1:
 lsl.w    #4,D1
 ror.b    #4,D1
 add.w    #$3030,D1
 lea      ChkKS10(pc),A0
 move.b   D1,(A0)
 ror.w    #8,D1
 addq.l   #2,A0
 cmp.b    #$2F,D1
 bne.s    ChkKS2
 cmp.w    #$312F,D1
 beq.s    ChkKS4     ;Kickstart 1.x
 bra.s    ChkKS3     ;Kickstart 3.x
ChkKS2:
 move.b   D1,(A0)
ChkKS3:
 addq.l   #3,A0
 bsr.s    ChkKS5
 move.w   D3,D2
 addq.l   #1,A0
 bsr.s    ChkKS5
 move.b   #")",(A0)
ChkKS4:
 move.l   4.w,A6     ;adres bazowy biblioteki Exec
 lea      ChkKS9(pc),A0
 move.l   A0,D2      ;adres danych do wywietlenia w CLI
 moveq    #17,D3     ;liczba bajtw do wywietlenia w CLI
 lea      ChkKS11(pc),A1 ;nazwa biblioteki DOS
 jsr      -408(A6)   ;otwiera bibliotek DOS (funkcja Exec:OldOpenLibrary)
 move.l   D0,A6      ;adres bazowy biblioteki DOS
 jsr      -60(A6)    ;zwraca uchwyt okna CLI do wywietlania danych. Jeli nie ma
                     ;takiego okna, to jest ono otwierane (funkcja DOS:Output).
 move.l   D0,D1      ;uchwyt okna CLI
 jsr      -48(A6)    ;wywietla dane w CLI (funkcja DOS:Write)
 move.l   A6,A1      ;adres bazowy biblioteki DOS
 move.l   4.w,A6     ;adres bazowy biblioteki Exec
 jsr      -414(A6)   ;zamyka bibliotek DOS (funkcja Exec:CloseLibrary)
 rts

;Konwersja 2-bajtw z rejestru D2 do systemu DEC-ASCII
ChkKS5:
 moveq    #$30,D1
 move.l   #$2710,D4
ChkKS6:
 move.b   #$2F,(A0)
ChkKS7:
 addq.b   #1,(A0)
 sub.w    D4,D2
 bcc.s    ChkKS7
 add.w    D4,D2
 cmp.b    (A0),D1
 beq.s    ChkKS8
 clr.b    D1
 addq.l   #1,A0
ChkKS8:
 divu     #$0A,D4
 bne.s    ChkKS6
 rts

ChkKS9:
 dc.b     "KS: "
ChkKS10:
 dc.b     "x.x (xx.x)  ",10
ChkKS11:
 dc.b     "dos.library",0

;Rozmiar: 234 B, linii kodu: 77